
                type_map = {1: "INTERNAL", 2: "EXTERNAL", 3: "CONFLUENT"}
                type = type_map[type]
                if self.trace_file is not None:
                    self.trace_file.write("%s TRANSITION in <%s> @ %s\n" % (type, model.getModelFullName(), model.timeLast[0]))
                    self.trace_file.write("  NEW STATE <%s>\n" % (model.state))
                    if type != "EXTERNAL":
                        self.trace_file.write("  OUTPUTFNC returned %s\n" % model.myOutput)
                    elif type != "INTERNAL":
                        self.trace_file.write("  inputs were %s\n" % model.my_input)
                    self.trace_file.write("  time_next: %s (ta: %s)\n" % (model.time_next[0], model.time_next[0] - model.timeLast[0]))